#ifndef _RMIRegistry_h__
#define _RMIRegistry_h__

#include <hpcxx_rts.h>
#include "MyGlobalPointerPack.h"
#include "Constants.h"
#include <sys/utsname.h>
#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#ifndef LINUX
#include <HPCxx_GlobalRef.h>
#include <HPCxx_GlobalRefImpl.h>
#include <HPCxx_Buffer.h>
#endif

#include "hpcxx_byte.h"
#include "HPCxx_String.h"
#include "BindObject.h"


template <class T>
class RMIRegistry {
private:
  nexus_startpoint_t registryStartpoint;
  nexus_startpoint_t localStartpoint;  
  nexus_startpoint_t remoteObjStartpoint;  
public:
  RMIRegistry();
  int bindRegistry(MyHPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN);
  int rebindRegistry(MyHPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN);
  int attachToRegistry(char *registryHost, unsigned short port);
  static int registrationID()  { return RMI_REGISTRATION_ID; }
  ~RMIRegistry();
  friend void hpcxx_pack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count);
  friend void hpcxx_unpack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count);
};
class dummy {
 private:
 public:
  static int registrationID() {  return DUMMY_REGISTRATION_ID;   }
  friend void hpcxx_pack(HPCxx_Buffer &b, dummy* pw, int count);
  friend void hpcxx_unpack(HPCxx_Buffer &b, dummy* pw, int count);
  
};

void hpcxx_pack(HPCxx_Buffer &b, dummy* pw, int count) {}
void hpcxx_unpack(HPCxx_Buffer &b, dummy* pw, int count) {}

#ifdef SOLARIS
#include "RMIRegistry.C"
#endif // SOLARIS

#endif // _RMIRegistry_h__








