package nexusrmi;

import nexus.BufferOverrunException;
import nexus.LostPrecisionException;
import java.util.Vector;

// This interface is implemented by all serializable objects.
// Its declaration is added to these objects by nexusrmis (javar).
public interface Nexusable
{
    // Write this object to the NexusBuffer. If this object has already been
    // serialized, write the index of the object in SerTab.
    public void serializeWrite(Serialize ser) throws BufferOverrunException;

    // Read an object from the NexusBuffer and return it. If an index is read,
    // return the object at that index in the SerTab.
    public Object serializeRead(Serialize ser) throws BufferOverrunException, LostPrecisionException;;

    // Return the size this object would occupy in a NexusBuffer. This method
    // will return the size of an index if it would have been written to the
    // NexusBuffer previously.
    public int serializeSizeof(Serialize ser);
}
