package rmitest;

import nexusrmi.*;
import nexusrmi.registry.*;

public class Client
{
  private Server obj1;//, obj2;
  private int PORT = 7000; // default port
  
  private boolean[] BoolArray = {false, true, false};
  private byte[] ByteArray = {21, 42, 65, 87};
  private short[] ShortArray = {321, 654, 987};
  private int[] IntArray = {4321, 6543, 8765};
  private long[] LongArray = {54321, 87654};
  private char[] CharArray = {'a', 'e', 'i', 'o', 'u'};
  private float[] FloatArray = {34.12f, 56.34f, 78.56f};
  private double[] DoubleArray = {56.3412, 78.5634};
  private String[] StringArray = {"Fabian", "Madhu", "Gannon"};
  private TestObj[] ObjectArray = {new TestObj(9), null, new TestObj(7)};
  
    
    public Client(String[] Args)
    {
	if ( (Args==null) || (Args.length<2) )
	{
	    System.out.println("Usage:  Client HOST <PORT>");
	    System.exit(1);
	}
	try
	{
		this.PORT = Integer.parseInt(Args[1]) ;
	    obj1 = (Server)Naming.lookup("rmi://"+Args[0]+":" + PORT + "/Server");
	    System.out.println("\n Client:: Lookup Succeeded ");
// 	    obj2 = (Server)Naming.lookup("rmi://"+Args[0]+":7000/CodedServer");
	}
	catch(Exception e)
	{
	    e.printStackTrace();
	    System.exit(1);
	}
    }

    public void start()
    {
	long t1, t2;

	t1 = System.currentTimeMillis();
	try
	{
	  System.out.println("\n Client:: obj1.putBool() ");
 	  obj1.putBool(true);
 	  System.out.println("getBool(): " + obj1.getBool());
 	  obj1.putByte((byte)98);
 	  System.out.println("getByte(): " + obj1.getByte());
 	  obj1.putShort((short)987);
 	  System.out.println("getShort(): " + obj1.getShort());
 	  obj1.putInt(9876);
 	  System.out.println("getInt(): " + obj1.getInt());
 	  obj1.putLong((long)98765);
 	  System.out.println("getLong(): " + obj1.getLong());
 	  obj1.putChar('*');
 	  System.out.println("getChar(): " + obj1.getChar());
	  obj1.putFloat(98.76f);
	  System.out.println("getFloat(): " + obj1.getFloat());
	  
	  obj1.putDouble(98.7654);
 	  System.out.println("getDouble(): " + obj1.getDouble());

 	  obj1.putString("Extreme Computing Lab");
 	  System.out.println("getString(): " + obj1.getString());

 	    try
 	    {
 		obj1.putClassObject(Class.forName("java.lang.Thread"));
 	    }
 	    catch(ClassNotFoundException e)
 	    {
 		e.printStackTrace();
 		System.exit(1);
 	    }
 	    System.out.println("getClassObject(): " + obj1.getClassObject());

 	    obj1.putObject(null);
 	    obj1.putObject(new TestObj(65));
 	    System.out.println("getObject():  TestObject(<int i = " + obj1.getObject().i  +  ">)");
	    
 	    obj1.putBoolArray(BoolArray);
	    boolean[] za = obj1.getBoolArray();
	    System.out.print("getBoolArray(): [ ");
	    if(za == null)
	      System.out.print("null");
	    else
 	      for(int i = 0; i < za.length; i++)
		System.out.print(za[i] + " ");
	    System.out.println("]");

 	    obj1.putByteArray(ByteArray);
 	    byte[] ba = obj1.getByteArray();
 	    System.out.print("getByteArray(): [ ");
 	    if(ba == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < ba.length; i++)
 		    System.out.print(ba[i] + " ");
 	    System.out.println("]");

	     // 	    obj1.putShortArray(null);

	    
	    obj1.putShortArray(ShortArray);
	    short[] sa = obj1.getShortArray();
	    System.out.print("getShortArray(): [ ");
	    if(sa == null)
	      System.out.print("null");
	    else
	      for(int i = 0; i < sa.length; i++)
		System.out.print(sa[i] + " ");
	    System.out.println("]");
	    
	    
 	    obj1.putIntArray(IntArray);
 	    int[] ia = obj1.getIntArray();
 	    System.out.print("getIntArray(): [ ");
 	    if(ia == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < ia.length; i++)
 		    System.out.print(ia[i] + " ");
 	    System.out.println("]");
	    
	    
 	    obj1.putLongArray(LongArray);
 	    long[] la =obj1.getLongArray();
 	    System.out.print("getLongArray(): [ ");
 	    if(la == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < la.length; i++)
 		    System.out.print(la[i] + " ");
 	    System.out.println("]");
	    
 	    obj1.putCharArray(CharArray);
 	    char[] ca = obj1.getCharArray();
 	    System.out.print("getCharArray(): [ ");
 	    if(ca == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < ca.length; i++)
 		    System.out.print(ca[i] + " ");
 	    System.out.println("]");

 	    obj1.putFloatArray(FloatArray);
 	    float[] fa = obj1.getFloatArray();
 	    System.out.print("getFloatArray(): [ ");
 	    if(fa == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < fa.length; i++)
 		    System.out.print(fa[i] + " ");
 	    System.out.println("]");

 	    obj1.putDoubleArray(DoubleArray);
 	    double[] da = obj1.getDoubleArray();
 	    System.out.print("getDoubleArray(): [ ");
 	    if(da == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < da.length; i++)
 		    System.out.print(da[i] + " ");
 	    System.out.println("]");

 	    obj1.putStringArray(StringArray);
 	    String[] ta = obj1.getStringArray();
 	    System.out.print("getStringArray(): [ ");
 	    if(ta == null)
	      System.out.print("null");
	    else
	      for(int i = 0; i < ta.length; i++)
		if(ta[i] == null)
		  System.out.print("null");
		else
		  System.out.print(ta[i] + " ");
 	    System.out.println("]");

 	    obj1.putObjectArray(ObjectArray);
 	    TestObj[] toa = obj1.getObjectArray();
 	    System.out.print("getObjectArray(): [ ");
 	    if(toa == null)
 		System.out.print("null");
 	    else
 		for(int i = 0; i < toa.length; i++)
 		    if(toa[i] == null)
 			System.out.print("null ");
 		    else
 			System.out.print(toa[i].i + " ");
 	    System.out.println("]");

	    System.out.println("\n ---------TESTING-CALLBACKS----------------\n");

	    System.out.println("\n Client: Invoking getInputPort() on Server ");
	    InputPortInterface iPort = obj1.getInputPort();
	    System.out.println(" Client: Received InputPort from Server \n");
	    System.out.println("\n Client: Invokng inputPort.sayHello(): -->\n" + iPort.sayHello());


	    TestObj testObj  = new TestObj(13);
	    System.out.println("\n Client: Invokng inputPort.write(TestObj<13>):  on Server");
	    testObj = (TestObj)(iPort.write(testObj));

	    System.out.println("\n Client: Once the client writes the TestObj<13> on to the InputPort of the Server, the port increments the value of the int by 1. To confirm that the write took place, we query the port for the value of the integer data member of its TestObject.  \n  ");


	    System.out.println("\n Client: Invoking inputPort.getI(): " + testObj.getI());
	    
	    System.out.println("\n --------------------------------------\n");

	    System.out.println("\n Common port has a very generic interface on the NexusRMI side. The interface looks like \t `public Object write(Object o) throws remote exeception.` \t  Moreever Common Port and InputPort both implement the same interface \n");  


	    System.out.println("\n Client: Invoking getCommonPort on Server ");
	    InputPortInterface cPort = obj1.getCommonPort();
	    System.out.println(" Client: Received CommonPort from Server \n");
	    System.out.println("\n Client: Invoking commonPort.sayHello(): -->\n" + cPort.sayHello());

	    CommonObj commonObj  = (new CommonObj(22));
	    commonObj = (CommonObj)(cPort.write(commonObj));
	    System.out.println("\n Client: Invoking commonPort.getI(22): -->\t" + commonObj.getI());


	    System.out.println("\n -------------END-OF-TEST--------------------\n");
	}
 	catch(Exception e)
	  {
 	    e.printStackTrace();
 	    System.exit(1);
	  }
	
	
	t2 = System.currentTimeMillis();
	System.out.println("Elapsed time: " + (t2 - t1) + " msec.");
    }
    
    public static void main(String[] Args)
    {
	Client c = new Client(Args);
	c.start();
	Communication.end();
    }
}

